include /masm32/include/masm32rt.inc ; 
compare proto:dword,:dword
.data
  str1 db "tango",0
  str2 db "romeo",0
  str3 db "delta",0
  str4 db "alpha",0
  ptrs dd str1,str2,str3,str4
.data?
  ptr1 dd ?
  ptr2 dd ?
  limit dd ?
  swapped db ?

;swap content of pointers
swap macro p1:req,p2:req
  push p2
  mov eax,p1
  mov p2,eax
  pop p1
endm

.code
start:
call print_tab
mov limit,3 ; no of strings -1
; bubble sort , compare 0->1,1->2,n-1->limit
;         then 1->2,n-1->limit,...
; finished, when no more swap was needed
init:
 mov swapped,0 ; init swap flag
  xor ebx,ebx ; use ebx as string counter
  ;because  ebx won't be destroyed by print macro
loop_:
; call upro to compare strings at address p1,p2
invoke compare, [ptrs+ebx*4],[ptrs+4+ebx*4]
test eax,eax ; is string2 > string1 ?
jz @f ;no
  ; else swap contents of pointers if needed
  swap [ptrs+ebx*4],[ptrs+4+ebx*4]
  mov swapped,1 ; set flag
@@:
  inc ebx ; next string
  cmp ebx,limit
  jb loop_ ; ebx < limit, -> next string
  dec limit ; last entry is already the highest 
  cmp swapped,0 ; finished, when no swap was needed in last run
  jne init
call print_tab
 exit
 
 print_tab proc uses ebx
   print "---- stringtab ----",13,10
   xor ebx,ebx
@@:
   print [ebx*4+ptrs],13,10
   inc ebx
   cmp ebx,4
   jnz @b
  print "---- end tab ------",13,10
   ret
 print_tab endp
; compare strings at address p1,p2 
 compare proc p1,p2
   xor eax,eax
    mov esi,[p1]
    mov edi,[p2]
  @cmp:
     cmpsb
    jg greater
    jl compare_exit
    cmp byte ptr[esi],0 ; end of string reached ?
    jne @cmp
greater:
   mov eax,1 ; use eax as result
compare_exit:
   ret
compare endp
 
end start